﻿#include <iostream>
#include <vector>
using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

int main()
{
	size_t number_count;
	cout << "Enter number count: ";
	cin >> number_count;
	vector<double> numbers(number_count);
	for (int i = 0; i < number_count; i++) {
		cin >> numbers[i];
	}
	size_t bin_count;
	cout << "Enter bin count: ";
	cin >> bin_count;
	vector<size_t> bins(bin_count);
	double min = numbers[0];
	double max = numbers[0];
	for (double x : numbers) {
		if (x < min) {
			min = x;
		}
		else if (x > max) {
			max = x;
		}
	}
	double bin_size = (max - min) / bin_count;
	for (size_t i = 0; i < number_count; i++) {
		bool found = false;
		for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
			auto lo = min + j * bin_size;
			auto hi = min + (j + 1) * bin_size;
			if ((lo <= numbers[i]) && (numbers[i] < hi)) {
				bins[j]++;
				found = true;
			}
		}
		if (!found) {
			bins[bin_count - 1]++;
		}
	}
	double max_count = bins[0];
	for (double x : bins) {
		if (x > max_count) {
			max_count = x;
		}
	}
	size_t height;
	bool flag = true;
	for (size_t j = 0; j < bin_count; j++) {
		if (bins[j] < 100) {
			cout << " ";
		}
		if (bins[j] < 10) {
			cout << " ";
		}
		cout << bins[j] << "|";
		if (max_count > MAX_ASTERISK) {
			for (size_t i = 0; i < bins[j]; i++) {
				if (bins[j] != MAX_ASTERISK && flag) {
					double count = bins[j];
					height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
					bins[j] = height;
					flag = false;
				}
			}
		}
		for (size_t i = 0; i < bins[j]; i++) {
			cout << "*";
		}
		cout << endl;
		flag = true;
	}

}